Name: sparse
Version: 0.4.5.rc1
Release: 3%{?dist}
Summary:    A semantic parser of source files
Group:      Development/Tools
License:    OSL 1.1
URL:        https://sparse.wiki.kernel.org
Source0:    http://www.kernel.org/pub/software/devel/sparse/dist/sparse-%{version}.tar.xz
BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: libxml2-devel gtk2-devel

Patch1:     0001-sparse-add-__builtin_va_arg_pack-and-__builtin_va_ar.patch

%description
Sparse is a semantic parser of source files: it's neither a compiler
(although it could be used as a front-end for one) nor is it a
preprocessor (although it contains as a part of it a preprocessing
phase).

It is meant to be a small - and simple - library.  Scanty and meager,
and partly because of that easy to use.  It has one mission in life:
create a semantic parse tree for some arbitrary user for further
analysis.  It's not a tokenizer, nor is it some generic context-free
parser.  In fact, context (semantics) is what it's all about - figuring
out not just what the grouping of tokens are, but what the _types_ are
that the grouping implies.

Sparse is primarily used in the development and debugging of the Linux kernel.

%package devel
Summary: Build environment for sparse-enabled apps
Group: Development/Libraries
Requires: pkgconfig
Provides: %{name}-static = %{version}-%{release}

%description devel
Development headers headers and static lib for sparse-enabled apps

%prep
%setup -q
%patch1 -p1

%define make_destdir \
make DESTDIR="%{buildroot}" PREFIX="%{_prefix}" \\\
     BINDIR="%{_bindir}" LIBDIR="%{_libdir}" \\\
     INCLUDEDIR="%{_includedir}" PKGCONFIGDIR="%{_libdir}/pkgconfig" \\\
%{nil}

%build
%ifarch sparcv9 sparc64
%make_destdir %{?_smp_mflags} CFLAGS="%{optflags} -Wwrite-strings -fPIC -DGCC_BASE=\\\"`gcc --print-file-name=`\\\""
%else
%make_destdir %{?_smp_mflags} CFLAGS="%{optflags} -Wwrite-strings -fpic -DGCC_BASE=\\\"`gcc --print-file-name=`\\\""
%endif

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_libdir}
%make_destdir install

%check
make check

%clean
rm -rf %{buildroot}
make clean

%files
%defattr(-,root,root,-)
%doc LICENSE README FAQ
%{_bindir}/sparse
%{_bindir}/cgcc
%{_bindir}/c2xml
%{_bindir}/test-inspect
%{_mandir}/man1/*

%files devel
%defattr(-,root,root,-)
%doc LICENSE
%{_includedir}/*
%{_libdir}/libsparse.a
%{_libdir}/pkgconfig/%{name}.pc

%changelog
* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4.5.rc1-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Fri Jul 19 2013 Jeff Layton <jlayton@redhat.com> - 0.4.5.rc1-2
- add test patch to silence warnings about __builtin_va_arg_pack() and
  __builtin_va_arg_pack_len()

* Tue Jul 09 2013 Jeff Layton <jlayton@redhat.com> - 0.4.5.rc1-1
- update to upstream rc1 release

* Thu Jun 27 2013 Jeff Layton <jlayton@redhat.com> - 0.4.4-6
- add built-in byte swap identifiers

* Fri Feb 15 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4.4-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4.4-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4.4-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Wed Nov 30 2011 Jeff Layton <jlayton@redhat.com> - 0.4.4-2
- fix project URL in specfile (again) (bz#732529)

* Wed Nov 30 2011 Jeff Layton <jlayton@redhat.com> - 0.4.4-1
- update to new upstream release (bz#757482)

* Mon Aug 29 2011 Jeff Layton <jlayton@redhat.com> - 0.4.3-4
- fix project URL in specfile (bz#732529)

* Thu Jun 23 2011 Jeff Layton <jlayton@redhat.com> - 0.4.3-3
- fix build with gcc 4.6 (bz#716105)

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Mon Nov 08 2010 Jeff Layton <jlayton@redhat.com> - 0.4.3-1
- Update to 0.4.3

* Sun Oct 18 2009 Jeff Layton <jlayton@redhat.com> - 0.4.2-1
- Update to 0.4.2

* Tue Sep 29 2009 Jeff Layton <jlayton@redhat.com> - 0.4.2rc1-1
- Update to 0.4.2rc1

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4.1-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sun Jun  1 2008 Tom "spot" Callaway <tcallawa@redhat.com? - 0.4.1-3
- use fPIC on sparcv9/sparc64

* Tue Feb 19 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 0.4.1-2
- Autorebuild for GCC 4.3

* Tue Nov 13 2007 Roland McGrath <roland@redhat.com> - 0.4.1-1
- Upgrade to 0.4.1

* Thu Nov  1 2007 Roland McGrath <roland@redhat.com> - 0.4-2
- Upgrade to 0.4
- Install man pages, c2xml.
- Run make check in rpmbuild.

* Tue Aug 28 2007 Roland McGrath <roland@redhat.com> - 0.3-2
- Canonicalize License: tag.

* Thu May  3 2007 Roland McGrath <roland@redhat.com> - 0.3-1
- Upgrade to 0.3

* Tue Dec 05 2006 Matt Domsch <Matt_Domsch@dell.com> 0.2-1
- Upgrade to 0.2, add -devel package

* Thu Nov 09 2006 Matt Domsch <Matt_Domsch@dell.com> 0.1-1
- Upgrade to 0.1, no need for snapshots, yea!  New upstream maintainer.
- cgcc now installed

* Thu Oct 26 2006 Matt Domsch <Matt_Domsch@dell.com> 0-0.1.20061026git
- Initial packaging for Fedora Extras
